# -*- coding: utf-8 -*-
# Algorithmus-von-Prim-original-ganz-funktional.py
# Diese Variante gliedert Teilfunktionen weitgehend aus.

# Graph von Turau:
mustergraph={ 1: [[2,4],[6,10], [7,5]],
              2: [[1,4],[3,7],[7,2]],
              3: [[2,7],[4,12],[7,1]],
              4: [[3,12],[5,4]],
              5: [[4,4],[6,3],[7,8]],
              6: [[1,10],[5,3],[7,4],[7,4]],
              7: [[1,5],[2,2],[6,4],[3,1],[5,8],[6,4]]}

# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneEin -----
# sortiert durch Einfügen
# Die Funktion ordnet eine einzelne Kante ein.
# rein funktionale Loesung
def ordneEin(kante, sortierte):
    if sortierte==[]:
        return [kante]
    elif kuerzer(kante, sortierte[0]):
        return [kante]+sortierte
    else:
        return [sortierte[0]]+ordneEin(kante,sortierte[1:])

# ----- ordneAlleEin -----
# Die Funktion ordnet eine Liste von Kanten ein.
# rein funktionale Loesung
def ordneAlleEin(kanten, sortierte):
    if kanten==[]:
        return sortierte
    else:
        return ordneAlleEin(kanten[1:],ordneEin(kanten[0], sortierte))

# ----- nachfolgeKanten -----
# Die Funktion bestimmt zu einer Ecke die Nachfolgekanten.
# rein funktionale Loesung
def nachfolgeKanten(ecke, graph):
    def lokal(nachfolger, kanten):
        if nachfolger==[]:
            return kanten
        return lokal(nachfolger[1:], kanten+[[ecke]+nachfolger[0]])
    return lokal(graph[ecke], [])

### ===== soweit funktional ueberarbeitet =====
# ----- entferneZyklen -----
# Entfernt Kanten, die einen Zyklus erzeugen.
def entferneZyklen(prioSchlange, enthalteneEcken):
    temp=[]
    for kante in prioSchlange:
        if not (kante[0] in enthalteneEcken):
            temp.append(kante)
        elif not (kante[1] in enthalteneEcken):
            temp.append(kante)
    return temp

# ----- kanteEinbauen -----
# Die Funktion baut die Kante ein und aktualisiert die Daten.
def kanteEinbauen(baum, enthalteneEcken, prioSchlange):
    baum.append(prioSchlange[0])
    if prioSchlange[0][0] in enthalteneEcken:
        enthalteneEcken.append(prioSchlange[0][1])
        neueEcke=prioSchlange[0][1]
    else:
        enthalteneEcken.append(prioSchlange[0][0])
        neueEcke=prioSchlange[0][0]
    prioSchlange.remove(prioSchlange[0])
    return neueEcke, baum, enthalteneEcken, prioSchlange

# ----- Schritt -----
# Der eigentliche Algorithmus
def Schritt(neueEcke, baum, enthalteneEcken, prioSchlange, graph):
    if len(enthalteneEcken)<len(graph):
        prioSchlange=entferneZyklen\
                      (ordneAlleEin\
                       (nachfolgeKanten(neueEcke, graph),\
                        prioSchlange),\
                       enthalteneEcken)
        neueEcke, baum, enthalteneEcken, prioSchlange=\
                  kanteEinbauen(baum, enthalteneEcken, prioSchlange)
        return Schritt(neueEcke, baum, enthalteneEcken, prioSchlange, graph)
    else:
        return baum

# ----- AvPrim -----
# Aufrufhülle für die Rekursion
def prim(graph, startEcke):
    return Schritt(startEcke, [], [startEcke], [], graph)

### ===== Testaufruf =====
print( prim(mustergraph, 1) )
import gallenbacher_graph
print( prim(gallenbacher_graph.gallenbacherGraph, 'I') )
