# -*- coding: utf-8 -*-
# Algorithmus-von-Prim-original.py

# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneEin -----
# sortiert durch Einfügen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

def nachfolgeKanten(ecke, graph):
    kanten=[]
    nachfolger=graph[ecke]
    for nach in nachfolger:
        kanten+=[[ecke]+nach]
    return kanten

# ----- Der eigentliche Algorithmus -----
# Aufrufhülle für die Rekursion
def AvPrim(graph, startEcke):
    baum=[]
    enthalteneEcken=[startEcke]
    neueEcke=startEcke
    prioSchlange=[]
    while len(enthalteneEcken)<len(graph):
        for kante in nachfolgeKanten(neueEcke, graph):
            prioSchlange=ordneEin(kante, prioSchlange)
        # Entferne alle Zyklen:
        temp=[]
        for kante in prioSchlange:
            if not (kante[0] in enthalteneEcken):
                temp.append(kante)
            elif not (kante[1] in enthalteneEcken):
                temp.append(kante)
        prioSchlange=temp
        # Die erste Kante setzt den Baum minimal fort
        baum.append(prioSchlange[0])
        if prioSchlange[0][0] in enthalteneEcken:
            enthalteneEcken.append(prioSchlange[0][1])
            neueEcke=prioSchlange[0][1]
        else:
            enthalteneEcken.append(prioSchlange[0][0])
            neueEcke=prioSchlange[0][0]
        prioSchlange.remove(prioSchlange[0])
    return baum

### Laenge bestimmen:
def laengeKanten(kanten):
    if kanten==[]: return 0
    return kanten[0][2]+laengeKanten(kanten[1:])


### ----- Ausgabe -----
def Ausgabe(graph, startKnoten):
    baum=AvPrim(graph, startKnoten)
    print( baum )
    print( 'Gesamtlaenge aller Kanten:', laengeKanten(baum))
### ===== Testaufruf =====
from gallenbacher_graph import gallenbacherGraph
Ausgabe(gallenbacherGraph,'I')


### Graph von Turau:
##mustergraph={ 1: [[2,4],[6,10], [7,5]],
##              2: [[1,4],[3,7],[7,2]],
##              3: [[2,7],[4,12],[7,1]],
##              4: [[3,12],[5,4]],
##              5: [[4,4],[6,3],[7,8]],
##              6: [[1,10],[5,3],[7,4],[7,4]],
##              7: [[1,5],[2,2],[6,4],[3,1],[5,8],[6,4]]}
##
##Ausgabe(mustergraph, 1)
